# $Id: common.make,v 1.2 2002/12/09 05:29:18 babolo Exp $

.if defined(PKG)
. undef THISBASEDIR
  THISBASEDIR	= ${BUILDINCLUDEDIR}
.endif

#######################################################################################################
subdir:
.for I in ${SUBDIR}
	@(cd ${I};\
          ${MAKE} ${MAKEFLAGS} PKG="${PKG}" VMAJOR="${VMAJOR}" VERS="${VERS}" DATE="${DATE}"\
                  CFLAGSPLUS="${CFLAGSPLUS}" PREFIX="${PREFIX}" CONFDIR="${CONFDIR}"\
                  LIBEDIR=${LIBEDIR} ROOTDATA="${ROOTDATA}"\
                  all\
        )
.endfor

#######################################################################################################

.for I in ${SGEN}
 MISC	+= ${I}.m4
${I}: ${THISBASEDIR}/define.make ${THISBASEDIR}/common.make Makefile ${THISBASEDIR}/def.m4 def.m4 ${I}.m4
	${M4} -DBUILDINCLUDEDIR=${BUILDINCLUDEDIR}\
              -DLIBEDIR=${LIBEDIR} -DBINOVER=${BINOVER} -DBINDIR=${BINDIR} -DDATADIR=${DATADIR}\
              -DVMAJOR=${VMAJOR} -DCAT=${CAT} -DSED=${SED} -DGREP=${GREP} -DAWK=${AWK}\
             ${THISBASEDIR}/def.m4 def.m4 ${I}.m4 > ${I}
.endfor

.for I in ${MANS}
${I}.gz: ${THISBASEDIR}/define.make ${THISBASEDIR}/common.make Makefile ${I}
	${GZIP} -cn ${I} > ${I}.gz
.endfor

.for I in ${PGMOD}
 MISC	+= ${I}.c
 DATA	+= ${I}.so.${VMAJOR}
${I}.so.${VMAJOR}: Makefile ${I}.c
	${CC} -fpic -shared -I${POSTGRESRC}/src/include -o ${I}.so.${VMAJOR} ${I}.c
.endfor

${PROG}: ${OBJS}
	${CC} ${LDFLAGS} ${OBJS} -o ${.TARGET}

#######################################################################################################
doclean:
	${RM} -f *.o *.so *.so.${VMAJOR} *.core .depend *.bak ${PROG} *.gz index.dir *.shtml ${CLEAN}
.if defined(TITLE)
	${RM} -f index.4tml
.endif
.for I in ${SUBDIR}
	@(cd ${I}; ${MAKE} ${MAKEFLAGS} PKG="${PKG}" RM="${RM}" MAKE="${MAKE}" VMAJOR="${VMAJOR}" clean)
.endfor

#######################################################################################################
doinstall:
.if defined(CONF)
	${MKDIR} -p ${CONFDIR}
. for I in ${CONF}
	${RM} -f ${CONFDIR}/${I}.orig
	${SED} -e 's|%%CONFDIR%%|${CONFDIR}|g'\
               -e 's|%%LIBEDIR%%|${LIBEDIR}|g'\
               -e 's|%%BINDIR%%|${BINDIR}|g'\
               -e 's|%%PREFIX%%|${PREFIX}|g'\
               -e 's|%%WWWROOT%%|${WWWROOT}|g'\
               -e 's|%%WWWROOTDATA%%|${WWWROOTDATA}|g'\
                  ${I} > ${CONFDIR}/${I}.orig
	${CHOWN} ${CHOWNER} ${CONFDIR}/${I}.orig
	${CHMOD} ${DATAMODE} ${CONFDIR}/${I}.orig
	@if [ ! -e ${CONFDIR}/${I} ]; then\
            ${CP} -p ${CONFDIR}/${I}.orig ${CONFDIR}/${I};\
        elif ! diff -bBdyaW 500 --suppress-common-lines ${CONFDIR}/${I} ${CONFDIR}/${I}.orig > /dev/null; then\
            ${ECHO} "";\
            ${ECHO} "*****************************************************************************";\
            ${ECHO} "*****************************************************************************";\
            ${ECHO} "*****************************************************************************";\
            ${ECHO} "********** !!! old             ${CONFDIR}/${I}      **********";\
            ${ECHO} "********** !!! differ from new ${CONFDIR}/${I}.orig **********";\
            ${ECHO} "";\
            diff ${CONFDIR}/${I} ${CONFDIR}/${I}.orig || true;\
            ${ECHO} "";\
            ${ECHO} "*****************************************************************************";\
            ${ECHO} "*****************************************************************************";\
            ${ECHO} "*****************************************************************************";\
            ${ECHO} "";\
        fi
. endfor
.endif
.if defined(PROG)
. if defined(BINOVER)
	${MKDIR} -p ${BINOVER}
.  for I in ${PROG}
	${INSTALL_PROGRAM} ${I} ${BINOVER}
.  endfor
. else
	${MKDIR} -p ${BINDIR}
.  for I in ${PROG}
	${INSTALL_PROGRAM} ${I} ${BINDIR}
.  endfor
. endif
.endif
.if defined(SCRIPTS)
. if defined(BINOVER)
	${MKDIR} -p ${BINOVER}
.  for I in ${SCRIPTS}
.   if defined(SCRIPTFILTER)
	${SED} -e 's|%%CONFDIR%%|${CONFDIR}|g'\
               -e 's|%%LIBEDIR%%|${LIBEDIR}|g'\
               -e 's|%%BINDIR%%|${BINDIR}|g'\
               -e 's|%%PREFIX%%|${PREFIX}|g'\
                  ${I} > ${BINOVER}/${I}
	${CHOWN} ${CHOWNER} ${BINOVER}/${I}
	${CHMOD} ${BINMODE} ${BINOVER}/${I}
.   else
	${INSTALL_SCRIPT} ${I} ${BINOVER}
.   endif
.  endfor
. else
	${MKDIR} -p ${BINDIR}
.  for I in ${SCRIPTS}
.   if defined(SCRIPTFILTER)
	${SED} -e 's|%%CONFDIR%%|${CONFDIR}|g'\
               -e 's|%%LIBEDIR%%|${LIBEDIR}|g'\
               -e 's|%%BINDIR%%|${BINDIR}|g'\
               -e 's|%%PREFIX%%|${PREFIX}|g'\
                  ${I} > ${BINDIR}/${I}
	${CHOWN} ${CHOWNER} ${BINDIR}/${I}
	${CHMOD} ${BINMODE} ${BINDIR}/${I}
.   else
	${INSTALL_SCRIPT} ${I} ${BINDIR}
.   endif
.  endfor
. endif
.endif
.if defined(MANZ)
	${MKDIR} -p ${MAN1DIR}
. for I in ${MANZ}
	${INSTALL_MAN} ${I} ${MAN1DIR}
. endfor
.endif
.if defined(DATADIR)
. if defined(DATA)
	${MKDIR} -p ${DATADIR}
	${INSTALL_DATA} ${DATA} ${DATADIR}
. endif
. if defined(SAMPLE)
	${MKDIR} -p ${DATADIR}
.  for I in ${SAMPLE}
	${INSTALL_DATA} ./${I} ${DATADIR}/${I}.sample
	@if [ ! -e ${DATADIR}/${I} ]; then\
            ${INSTALL_DATA} ./${I} ${DATADIR}/;\
        fi
.  endfor
. endif
.endif

subdirinstall:
.for I in ${SUBDIR}
	@(cd ${I};\
          ${MAKE} ${MAKEFLAGS} PKG="${PKG}" VMAJOR="${VMAJOR}"\
                  BINMODE="${BINMODE}" MANMODE="${MANMODE}" DATAMODE="${DATAMODE}"\
                  INSTALL_PROGRAM="${INSTALL_PROGRAM}"\
                  INSTALL_SCRIPT="${INSTALL_SCRIPT}"\
                  INSTALL_DATA="${INSTALL_DATA}"\
                  INSTALL_MAN="${INSTALL_MAN}"\
                  OWNER="${OWNER}" CHOWNER="${CHOWNER}"\
                  PREFIX="${PREFIX}" BINDIR="${BINDIR}" MAN1DIR="${MAN1DIR}"\
                  LIBEDIR="${LIBEDIR}" CONFDIR="${CONFDIR}" ROOTDATA="${ROOTDATA}"\
                  install\
        )
.endfor

#######################################################################################################
tarball:
	${MKDIR} -p ${DISTNM}
	${CP} -p ${SRCS} ${MANS} ${MISC} ${SQLS} ${CONF} ${DISTNM}/
.for I in ${SUBDIR}
	@(cd ${I}; ${MAKE} PKG="${PKG}" ${MAKEFLAGS} DISTNM="../${DISTNM}/${I}" tarball)
.endfor
.if defined(VMAJOR)
	${TAR} -czvf ${DISTNM}.tar.gz ${DISTNM}
	${RM} -rf ${DISTNM}
.endif

notify:
	@${ECHO} "===> make in ${PKG}:${PWD}"

preall:

postall:

preclean:

postclean:

preinstall:

postinstall:

clean: notify preclean doclean postclean

install: notify all preinstall doinstall subdirinstall postinstall

all: notify preall ${THISBASEDIR}/common.make Makefile ${PROG} ${SCRIPTS} ${MANZ} subdir ${DATA} postall

